Index: CPC stuff/ch376/ramcard.sch
===================================================================
--- CPC stuff/ch376/ramcard.sch	(revision f3b60868a22121cdf968b7f5f2912e66b33a106f)
+++ CPC stuff/ch376/ramcard.sch	(revision 208ae00cbbf7a82fe221b635f8c62b898a055ac6)
@@ -7,4 +7,5 @@
 LIBS:regul
 LIBS:opendous
+LIBS:switches
 LIBS:ramcard-cache
 EELAYER 25 0
@@ -165,5 +166,4 @@
 D0
 NoConn ~ 900  4700
-NoConn ~ 900  4600
 NoConn ~ 900  4500
 NoConn ~ 900  4400
@@ -204,5 +204,5 @@
 F 0 "C3" H 1500 3900 50  0000 L CNN
 F 1 "C" H 1500 3700 50  0000 L CNN
-F 2 "Capacitors_SMD:C_1206" H 1450 3800 60  0001 C CNN
+F 2 "Capacitors_SMD:C_0805" H 1450 3800 60  0001 C CNN
 F 3 "" H 1450 3800 60  0001 C CNN
 	1    1450 3800
@@ -954,5 +954,5 @@
 Text Label 9300 2000 0    60   ~ 0
 12MHz
-Text Label 6500 6850 2    60   ~ 0
+Text Label 6150 5100 2    60   ~ 0
 24MHz
 NoConn ~ 5900 2700
@@ -1006,79 +1006,61 @@
 Wire Wire Line
 	9600 2000 9300 2000
-$Comp
-L FT230X U4
-U 1 1 5622DCC5
-P 5550 6550
-F 0 "U4" H 5550 6450 60  0000 C CNN
-F 1 "FT230X" H 5800 6050 60  0000 C CNN
-F 2 "Housings_SSOP:SSOP-16_3.9x4.9mm_Pitch0.635mm" H 5550 6750 60  0001 C CNN
-F 3 "" H 5550 6750 60  0000 C CNN
-	1    5550 6550
-	1    0    0    -1  
-$EndComp
-Wire Wire Line
-	4850 6150 5600 6150
-Wire Wire Line
-	5600 6150 5600 5900
+Wire Wire Line
+	4500 4000 5250 4000
+Wire Wire Line
+	5250 4000 5250 3750
 $Comp
 L VCC #PWR017
 U 1 1 5622DFD0
-P 5500 5850
-F 0 "#PWR017" H 5500 5700 50  0001 C CNN
-F 1 "VCC" H 5500 6000 50  0000 C CNN
-F 2 "" H 5500 5850 60  0000 C CNN
-F 3 "" H 5500 5850 60  0000 C CNN
-	1    5500 5850
-	1    0    0    -1  
-$EndComp
-Wire Wire Line
-	5500 5900 5500 5850
-Wire Wire Line
-	3400 7200 5600 7200
+P 5150 3700
+F 0 "#PWR017" H 5150 3550 50  0001 C CNN
+F 1 "VCC" H 5150 3850 50  0000 C CNN
+F 2 "" H 5150 3700 60  0000 C CNN
+F 3 "" H 5150 3700 60  0000 C CNN
+	1    5150 3700
+	1    0    0    -1  
+$EndComp
+Wire Wire Line
+	5150 3750 5150 3700
 $Comp
 L GND #PWR018
 U 1 1 5622E2CA
-P 5550 7300
-F 0 "#PWR018" H 5550 7050 50  0001 C CNN
-F 1 "GND" H 5550 7150 50  0000 C CNN
-F 2 "" H 5550 7300 60  0000 C CNN
-F 3 "" H 5550 7300 60  0000 C CNN
-	1    5550 7300
-	1    0    0    -1  
-$EndComp
-Wire Wire Line
-	5550 7300 5550 7200
-Connection ~ 5550 7200
-Text Label 6350 6150 2    60   ~ 0
+P 5200 5550
+F 0 "#PWR018" H 5200 5300 50  0001 C CNN
+F 1 "GND" H 5200 5400 50  0000 C CNN
+F 2 "" H 5200 5550 60  0000 C CNN
+F 3 "" H 5200 5550 60  0000 C CNN
+	1    5200 5550
+	1    0    0    -1  
+$EndComp
+Text Label 6000 4000 2    60   ~ 0
 RX
-Text Label 6350 6250 2    60   ~ 0
+Text Label 6000 4100 2    60   ~ 0
 TX
 Wire Wire Line
-	6150 6150 6350 6150
-Wire Wire Line
-	6150 6250 6350 6250
-Text Label 6350 6350 2    60   ~ 0
+	5800 4000 6000 4000
+Wire Wire Line
+	5800 4100 6000 4100
+Text Label 6000 4200 2    60   ~ 0
 /CTS
-Text Label 6350 6450 2    60   ~ 0
+Text Label 6000 4300 2    60   ~ 0
 /RTS
 Wire Wire Line
-	6150 6350 6350 6350
-Wire Wire Line
-	6150 6450 6350 6450
+	5800 4200 6000 4200
+Wire Wire Line
+	5800 4300 6000 4300
 Text Label 5800 2700 3    60   ~ 0
 24MHz
-Text Label 6500 6750 2    60   ~ 0
+Text Label 6150 5000 2    60   ~ 0
 12MHz
 Wire Wire Line
-	6150 6650 6500 6650
-Wire Wire Line
-	6150 6750 6500 6750
-Text Label 6500 6650 2    60   ~ 0
+	5800 4900 6150 4900
+Wire Wire Line
+	5800 5000 6150 5000
+Text Label 6000 4400 2    60   ~ 0
 GPO2
 Wire Wire Line
-	6150 6850 6500 6850
-Wire Wire Line
-	6150 6950 6650 6950
-Text Label 6650 6950 2    60   ~ 0
+	5800 5100 6150 5100
+Text Label 6300 5200 2    60   ~ 0
 VBUS_Sense
 Wire Wire Line
@@ -1094,18 +1076,14 @@
 Wire Wire Line
 	6100 800  6100 750 
-Wire Wire Line
-	4950 6950 5500 6950
-Wire Wire Line
-	5500 6950 5500 6150
-Connection ~ 5500 6150
+Connection ~ 5150 4000
 $Comp
 L R R4
 U 1 1 562364F7
-P 4700 6500
-F 0 "R4" V 4780 6500 50  0000 C CNN
-F 1 "27" V 4700 6500 50  0000 C CNN
-F 2 "Resistors_SMD:R_0805" V 4630 6500 30  0001 C CNN
-F 3 "" H 4700 6500 30  0000 C CNN
-	1    4700 6500
+P 4350 4350
+F 0 "R4" V 4430 4350 50  0000 C CNN
+F 1 "27" V 4350 4350 50  0000 C CNN
+F 2 "Resistors_SMD:R_0805" V 4280 4350 30  0001 C CNN
+F 3 "" H 4350 4350 30  0000 C CNN
+	1    4350 4350
 	0    1    1    0   
 $EndComp
@@ -1113,25 +1091,25 @@
 L R R5
 U 1 1 562365B5
-P 4700 6600
-F 0 "R5" V 4780 6600 50  0000 C CNN
-F 1 "27" V 4700 6600 50  0000 C CNN
-F 2 "Resistors_SMD:R_0805" V 4630 6600 30  0001 C CNN
-F 3 "" H 4700 6600 30  0000 C CNN
-	1    4700 6600
+P 4350 4450
+F 0 "R5" V 4430 4450 50  0000 C CNN
+F 1 "27" V 4350 4450 50  0000 C CNN
+F 2 "Resistors_SMD:R_0805" V 4280 4450 30  0001 C CNN
+F 3 "" H 4350 4450 30  0000 C CNN
+	1    4350 4450
 	0    1    1    0   
 $EndComp
 Wire Wire Line
-	4850 6500 4950 6500
-Wire Wire Line
-	4850 6600 4950 6600
+	4500 4350 4600 4350
+Wire Wire Line
+	4500 4450 4600 4450
 $Comp
 L C C8
 U 1 1 56236861
-P 4250 6850
-F 0 "C8" H 4275 6950 50  0000 L CNN
-F 1 "47pF" H 4275 6750 50  0000 L CNN
-F 2 "Capacitors_SMD:C_0805" H 4288 6700 30  0001 C CNN
-F 3 "" H 4250 6850 60  0000 C CNN
-	1    4250 6850
+P 3900 4700
+F 0 "C8" H 3925 4800 50  0000 L CNN
+F 1 "47pF" H 3925 4600 50  0000 L CNN
+F 2 "Capacitors_SMD:C_0805" H 3938 4550 30  0001 C CNN
+F 3 "" H 3900 4700 60  0000 C CNN
+	1    3900 4700
 	1    0    0    -1  
 $EndComp
@@ -1139,10 +1117,10 @@
 L C C9
 U 1 1 562368CE
-P 4450 6850
-F 0 "C9" H 4475 6950 50  0000 L CNN
-F 1 "47pF" H 4475 6750 50  0000 L CNN
-F 2 "Capacitors_SMD:C_0805" H 4488 6700 30  0001 C CNN
-F 3 "" H 4450 6850 60  0000 C CNN
-	1    4450 6850
+P 4100 4700
+F 0 "C9" H 4125 4800 50  0000 L CNN
+F 1 "47pF" H 4125 4600 50  0000 L CNN
+F 2 "Capacitors_SMD:C_0805" H 4138 4550 30  0001 C CNN
+F 3 "" H 4100 4700 60  0000 C CNN
+	1    4100 4700
 	1    0    0    -1  
 $EndComp
@@ -1150,39 +1128,38 @@
 L USB_B P3
 U 1 1 56236A6D
-P 3800 6600
-F 0 "P3" H 4000 6400 50  0000 C CNN
-F 1 "USB_B" H 3750 6800 50  0000 C CNN
-F 2 "Connect:USB_B" V 3750 6500 60  0001 C CNN
-F 3 "" V 3750 6500 60  0000 C CNN
-	1    3800 6600
+P 3450 4450
+F 0 "P3" H 3650 4250 50  0000 C CNN
+F 1 "USB_B" H 3400 4650 50  0000 C CNN
+F 2 "Connect:USB_B" V 3400 4350 60  0001 C CNN
+F 3 "" V 3400 4350 60  0000 C CNN
+	1    3450 4450
 	0    -1   1    0   
 $EndComp
 Wire Wire Line
-	4550 6500 4100 6500
-Wire Wire Line
-	4550 6600 4100 6600
-Wire Wire Line
-	4250 6700 4250 6600
-Connection ~ 4250 6600
-Wire Wire Line
-	4450 6700 4450 6500
-Connection ~ 4450 6500
-Wire Wire Line
-	4100 6700 4100 7000
-Wire Wire Line
-	4100 7000 4450 7000
-Connection ~ 4250 7000
-Wire Wire Line
-	4250 7200 4250 7000
-Connection ~ 5500 7200
+	4200 4350 3750 4350
+Wire Wire Line
+	4200 4450 3750 4450
+Wire Wire Line
+	3900 4550 3900 4450
+Connection ~ 3900 4450
+Wire Wire Line
+	4100 4550 4100 4350
+Connection ~ 4100 4350
+Wire Wire Line
+	3750 4550 3750 4850
+Wire Wire Line
+	3750 4850 4100 4850
+Connection ~ 3900 4850
+Wire Wire Line
+	3900 4850 3900 5450
 $Comp
 L R R2
 U 1 1 562372BC
-P 3400 6400
-F 0 "R2" V 3480 6400 50  0000 C CNN
-F 1 "4k7" V 3400 6400 50  0000 C CNN
-F 2 "Resistors_SMD:R_0805" V 3330 6400 30  0001 C CNN
-F 3 "" H 3400 6400 30  0000 C CNN
-	1    3400 6400
+P 3050 4250
+F 0 "R2" V 3130 4250 50  0000 C CNN
+F 1 "4k7" V 3050 4250 50  0000 C CNN
+F 2 "Resistors_SMD:R_0805" V 2980 4250 30  0001 C CNN
+F 3 "" H 3050 4250 30  0000 C CNN
+	1    3050 4250
 	1    0    0    -1  
 $EndComp
@@ -1190,39 +1167,35 @@
 L R R3
 U 1 1 5623736D
-P 3400 6800
-F 0 "R3" V 3480 6800 50  0000 C CNN
-F 1 "10k" V 3400 6800 50  0000 C CNN
-F 2 "Resistors_SMD:R_0805" V 3330 6800 30  0001 C CNN
-F 3 "" H 3400 6800 30  0000 C CNN
-	1    3400 6800
-	1    0    0    -1  
-$EndComp
-Wire Wire Line
-	4100 6400 4100 6250
-Wire Wire Line
-	4100 6250 3400 6250
-Wire Wire Line
-	3400 6650 3400 6550
-Wire Wire Line
-	3400 6950 3400 7200
-Connection ~ 4250 7200
-Wire Wire Line
-	3400 6600 3250 6600
-Wire Wire Line
-	3250 6600 3250 7550
-Wire Wire Line
-	3250 7550 6650 7550
-Wire Wire Line
-	6650 7550 6650 6950
-Connection ~ 3400 6600
+P 3050 4650
+F 0 "R3" V 3130 4650 50  0000 C CNN
+F 1 "10k" V 3050 4650 50  0000 C CNN
+F 2 "Resistors_SMD:R_0805" V 2980 4650 30  0001 C CNN
+F 3 "" H 3050 4650 30  0000 C CNN
+	1    3050 4650
+	1    0    0    -1  
+$EndComp
+Wire Wire Line
+	3750 4250 3750 4100
+Wire Wire Line
+	3750 4100 3050 4100
+Wire Wire Line
+	3050 4500 3050 4400
+Wire Wire Line
+	3050 4800 3050 5050
+Connection ~ 3900 5050
+Wire Wire Line
+	3050 4450 2900 4450
+Wire Wire Line
+	2900 4450 2900 5750
+Connection ~ 3050 4450
 $Comp
 L C C10
 U 1 1 56237A25
-P 4700 6150
-F 0 "C10" H 4750 6250 50  0000 L CNN
-F 1 "C" H 4750 6050 50  0000 L CNN
-F 2 "Capacitors_SMD:C_0805" H 4700 6150 60  0001 C CNN
-F 3 "" H 4700 6150 60  0001 C CNN
-	1    4700 6150
+P 4350 4000
+F 0 "C10" H 4400 4100 50  0000 L CNN
+F 1 "C" H 4400 3900 50  0000 L CNN
+F 2 "Capacitors_SMD:C_0805" H 4350 4000 60  0001 C CNN
+F 3 "" H 4350 4000 60  0001 C CNN
+	1    4350 4000
 	0    1    1    0   
 $EndComp
@@ -1230,24 +1203,22 @@
 L GND #PWR019
 U 1 1 56237FF9
-P 4350 6150
-F 0 "#PWR019" H 4350 5900 50  0001 C CNN
-F 1 "GND" H 4350 6000 50  0000 C CNN
-F 2 "" H 4350 6150 60  0000 C CNN
-F 3 "" H 4350 6150 60  0000 C CNN
-	1    4350 6150
-	1    0    0    -1  
-$EndComp
-Wire Wire Line
-	4350 6150 4550 6150
-Connection ~ 4950 6150
-Wire Notes Line
-	3100 7700 6800 7700
-Wire Notes Line
-	6800 7700 6800 5550
-Wire Notes Line
-	6800 5550 3100 5550
-Wire Notes Line
-	3100 5550 3100 7700
-Text Notes 3300 5800 0    60   ~ 0
+P 4000 4000
+F 0 "#PWR019" H 4000 3750 50  0001 C CNN
+F 1 "GND" H 4000 3850 50  0000 C CNN
+F 2 "" H 4000 4000 60  0000 C CNN
+F 3 "" H 4000 4000 60  0000 C CNN
+	1    4000 4000
+	1    0    0    -1  
+$EndComp
+Wire Wire Line
+	4000 4000 4200 4000
+Connection ~ 4600 4000
+Wire Notes Line
+	6450 3400 6450 6700
+Wire Notes Line
+	6450 3400 2750 3400
+Wire Notes Line
+	2750 3400 2750 6700
+Text Notes 2950 3650 0    60   ~ 0
 UART to USB bridge
 Text Label 2050 5100 2    60   ~ 0
@@ -1257,121 +1228,70 @@
 Text Label 800  4900 0    60   ~ 0
 BUSRST
-Text Label 4100 3700 0    60   ~ 0
+Text Label 8800 4550 0    60   ~ 0
 /INT
-Text Label 4100 4200 0    60   ~ 0
+Text Label 8800 5050 0    60   ~ 0
 /NMI
 Wire Wire Line
-	4000 3700 4100 3700
-Wire Wire Line
-	4000 4200 4100 4200
+	8700 4550 8800 4550
+Wire Wire Line
+	8700 5050 8800 5050
 Text Label 7100 1300 0    60   ~ 0
 /OUT1
 Text Label 7100 1600 0    60   ~ 0
 /OUT2
-Text Label 2450 3600 0    60   ~ 0
+Text Label 7150 4450 0    60   ~ 0
 /OUT1
-Text Label 2450 4300 0    60   ~ 0
+Text Label 7150 5150 0    60   ~ 0
 /OUT2
 Wire Wire Line
-	2450 4300 2800 4300
-Wire Wire Line
-	2450 3600 2800 3600
-Wire Wire Line
-	2800 4100 2800 3800
+	7150 5150 7500 5150
+Wire Wire Line
+	7150 4450 7500 4450
+Wire Wire Line
+	7500 4950 7500 4650
 Text Label 7100 1700 0    60   ~ 0
 INTRPT
-Text Label 2450 3950 0    60   ~ 0
+Text Label 7150 4800 0    60   ~ 0
 INTRPT
 Wire Wire Line
-	2450 3950 2800 3950
-Connection ~ 2800 3950
-Text Label 2450 4800 0    60   ~ 0
+	7150 4800 7500 4800
+Connection ~ 7500 4800
+Text Label 7150 5650 0    60   ~ 0
 /RESET
 Wire Wire Line
-	2450 4800 2800 4800
-Wire Wire Line
-	2800 4700 2800 4900
-Connection ~ 2800 4800
-Text Label 4000 4800 0    60   ~ 0
+	7150 5650 7500 5650
+Wire Wire Line
+	7500 5550 7500 5750
+Connection ~ 7500 5650
+Text Label 8700 5650 0    60   ~ 0
 PRESET
 Text Label 7100 1200 0    60   ~ 0
 PRESET
-Text Label 8400 1050 0    60   ~ 0
-PRESET
-$Comp
-L JUMPER JP3
-U 1 1 5623D82B
-P 9050 1050
-F 0 "JP3" H 9050 1200 50  0000 C CNN
-F 1 "JUMPER" H 9050 970 50  0000 C CNN
-F 2 "opendous:SIL-2_Opendous" H 9050 1050 60  0001 C CNN
-F 3 "" H 9050 1050 60  0000 C CNN
-	1    9050 1050
-	1    0    0    -1  
-$EndComp
-$Comp
-L JUMPER JP2
-U 1 1 5623DC02
-P 9050 750
-F 0 "JP2" H 9050 900 50  0000 C CNN
-F 1 "JUMPER" H 9050 670 50  0000 C CNN
-F 2 "opendous:SIL-2_Opendous" H 9050 750 60  0001 C CNN
-F 3 "" H 9050 750 60  0000 C CNN
-	1    9050 750 
-	1    0    0    -1  
-$EndComp
-Wire Wire Line
-	8400 1050 8750 1050
-Wire Wire Line
-	9350 1050 9350 900 
-Wire Wire Line
-	9350 800  9350 750 
-Wire Wire Line
-	8750 750  8400 750 
-Text Label 8400 750  0    60   ~ 0
-/DCD
 Text Label 6300 800  1    60   ~ 0
 /DCD
-$Comp
-L JUMPER3 JP1
-U 1 1 5623E7BA
-P 5650 3400
-F 0 "JP1" H 5700 3300 50  0000 L CNN
-F 1 "JUMPER3" H 5650 3500 50  0000 C BNN
-F 2 "opendous:SIL-3-Blank" H 5650 3400 60  0001 C CNN
-F 3 "" H 5650 3400 60  0000 C CNN
-	1    5650 3400
-	1    0    0    -1  
-$EndComp
-Text Label 5650 3650 2    60   ~ 0
+Text Label 8200 3000 2    60   ~ 0
 GPO2
-Wire Wire Line
-	5650 3650 5650 3500
-Wire Wire Line
-	5400 3400 5100 3400
-Wire Wire Line
-	5900 3400 6200 3400
-Text Label 6200 3400 0    60   ~ 0
+Text Label 9100 3100 0    60   ~ 0
 BUSRST
-Text Label 5100 3400 0    60   ~ 0
-/RI
-Text Label 6200 800  1    60   ~ 0
-/RI
-Wire Wire Line
-	5750 4350 5750 4150
-Wire Wire Line
-	5600 4400 5600 4250
-Wire Wire Line
-	5600 4250 5750 4250
-Connection ~ 5750 4250
+Text Label 9100 3000 0    60   ~ 0
+/DSR
+Text Label 6400 800  1    60   ~ 0
+/DSR
+Wire Wire Line
+	8050 3900 8050 3700
+Wire Wire Line
+	7900 3950 7900 3800
+Wire Wire Line
+	7900 3800 8050 3800
+Connection ~ 8050 3800
 $Comp
 L VCC #PWR020
 U 1 1 56241F46
-P 5600 4400
-F 0 "#PWR020" H 5600 4250 50  0001 C CNN
-F 1 "VCC" H 5600 4550 50  0000 C CNN
-F 2 "" H 5600 4400 60  0000 C CNN
-F 3 "" H 5600 4400 60  0000 C CNN
-	1    5600 4400
+P 7900 3950
+F 0 "#PWR020" H 7900 3800 50  0001 C CNN
+F 1 "VCC" H 7900 4100 50  0000 C CNN
+F 2 "" H 7900 3950 60  0000 C CNN
+F 3 "" H 7900 3950 60  0000 C CNN
+	1    7900 3950
 	-1   0    0    1   
 $EndComp
@@ -1379,10 +1299,10 @@
 L 74LS38 U5
 U 1 1 5623C69E
-P 3400 3700
-F 0 "U5" H 3400 3750 60  0000 C CNN
-F 1 "74LS38" H 3400 3650 60  0000 C CNN
-F 2 "Housings_SOIC:SOIC-14_3.9x8.7mm_Pitch1.27mm" H 3400 3700 60  0001 C CNN
-F 3 "" H 3400 3700 60  0000 C CNN
-	1    3400 3700
+P 8100 4550
+F 0 "U5" H 8100 4600 60  0000 C CNN
+F 1 "74LS38" H 8100 4500 60  0000 C CNN
+F 2 "Housings_SOIC:SOIC-14_3.9x8.7mm_Pitch1.27mm" H 8100 4550 60  0001 C CNN
+F 3 "" H 8100 4550 60  0000 C CNN
+	1    8100 4550
 	1    0    0    -1  
 $EndComp
@@ -1390,10 +1310,10 @@
 L 74LS38 U5
 U 2 1 5623C7AF
-P 3400 4200
-F 0 "U5" H 3400 4250 60  0000 C CNN
-F 1 "74LS38" H 3400 4150 60  0000 C CNN
-F 2 "Housings_SOIC:SOIC-14_3.9x8.7mm_Pitch1.27mm" H 3400 4200 60  0001 C CNN
-F 3 "" H 3400 4200 60  0000 C CNN
-	2    3400 4200
+P 8100 5050
+F 0 "U5" H 8100 5100 60  0000 C CNN
+F 1 "74LS38" H 8100 5000 60  0000 C CNN
+F 2 "Housings_SOIC:SOIC-14_3.9x8.7mm_Pitch1.27mm" H 8100 5050 60  0001 C CNN
+F 3 "" H 8100 5050 60  0000 C CNN
+	2    8100 5050
 	1    0    0    -1  
 $EndComp
@@ -1401,10 +1321,10 @@
 L 74LS38 U5
 U 3 1 5623C846
-P 3400 4800
-F 0 "U5" H 3400 4850 60  0000 C CNN
-F 1 "74LS38" H 3400 4750 60  0000 C CNN
-F 2 "Housings_SOIC:SOIC-14_3.9x8.7mm_Pitch1.27mm" H 3400 4800 60  0001 C CNN
-F 3 "" H 3400 4800 60  0000 C CNN
-	3    3400 4800
+P 8100 5650
+F 0 "U5" H 8100 5700 60  0000 C CNN
+F 1 "74LS38" H 8100 5600 60  0000 C CNN
+F 2 "Housings_SOIC:SOIC-14_3.9x8.7mm_Pitch1.27mm" H 8100 5650 60  0001 C CNN
+F 3 "" H 8100 5650 60  0000 C CNN
+	3    8100 5650
 	1    0    0    -1  
 $EndComp
@@ -1412,23 +1332,23 @@
 L 74LS38 U5
 U 4 1 5623C8AF
-P 6350 4250
-F 0 "U5" H 6350 4300 60  0000 C CNN
-F 1 "74LS38" H 6350 4200 60  0000 C CNN
-F 2 "Housings_SOIC:SOIC-14_3.9x8.7mm_Pitch1.27mm" H 6350 4250 60  0001 C CNN
-F 3 "" H 6350 4250 60  0000 C CNN
-	4    6350 4250
-	1    0    0    -1  
-$EndComp
-Wire Wire Line
-	4000 4800 4550 4800
+P 8650 3800
+F 0 "U5" H 8650 3850 60  0000 C CNN
+F 1 "74LS38" H 8650 3750 60  0000 C CNN
+F 2 "Housings_SOIC:SOIC-14_3.9x8.7mm_Pitch1.27mm" H 8650 3800 60  0001 C CNN
+F 3 "" H 8650 3800 60  0000 C CNN
+	4    8650 3800
+	1    0    0    -1  
+$EndComp
+Wire Wire Line
+	8700 5650 9250 5650
 $Comp
 L R R6
 U 1 1 5623E101
-P 4550 4650
-F 0 "R6" V 4630 4650 50  0000 C CNN
-F 1 "4K7" V 4550 4650 50  0000 C CNN
-F 2 "Resistors_SMD:R_0805" V 4480 4650 30  0001 C CNN
-F 3 "" H 4550 4650 30  0000 C CNN
-	1    4550 4650
+P 9250 5500
+F 0 "R6" V 9330 5500 50  0000 C CNN
+F 1 "4K7" V 9250 5500 50  0000 C CNN
+F 2 "Resistors_SMD:R_0805" V 9180 5500 30  0001 C CNN
+F 3 "" H 9250 5500 30  0000 C CNN
+	1    9250 5500
 	1    0    0    -1  
 $EndComp
@@ -1436,13 +1356,124 @@
 L VCC #PWR021
 U 1 1 5623E535
-P 4550 4350
-F 0 "#PWR021" H 4550 4200 50  0001 C CNN
-F 1 "VCC" H 4550 4500 50  0000 C CNN
-F 2 "" H 4550 4350 60  0000 C CNN
-F 3 "" H 4550 4350 60  0000 C CNN
-	1    4550 4350
-	1    0    0    -1  
-$EndComp
-Wire Wire Line
-	4550 4500 4550 4350
+P 9250 5200
+F 0 "#PWR021" H 9250 5050 50  0001 C CNN
+F 1 "VCC" H 9250 5350 50  0000 C CNN
+F 2 "" H 9250 5200 60  0000 C CNN
+F 3 "" H 9250 5200 60  0000 C CNN
+	1    9250 5200
+	1    0    0    -1  
+$EndComp
+Wire Wire Line
+	9250 5350 9250 5200
+$Comp
+L SW_DIP_x4 S1
+U 1 1 56268B08
+P 8650 3150
+F 0 "S1" H 8650 2900 50  0000 C CNN
+F 1 "SW_DIP_x4" H 8650 3400 50  0000 C CNN
+F 2 "Buttons_Switches_ThroughHole:SW_DIP_x4_Slide" H 8600 3150 60  0001 C CNN
+F 3 "" H 8600 3150 60  0000 C CNN
+	1    8650 3150
+	1    0    0    -1  
+$EndComp
+Wire Wire Line
+	8200 3000 8350 3000
+Wire Wire Line
+	8350 3000 8350 3100
+Wire Wire Line
+	8950 3000 9100 3000
+Wire Wire Line
+	8950 3100 9100 3100
+Text Label 7900 3200 0    60   ~ 0
+PRESET
+Text Label 9100 3200 0    60   ~ 0
+RSTI
+Wire Wire Line
+	8950 3200 9100 3200
+Wire Wire Line
+	7900 3200 8350 3200
+Text Label 9350 900  0    60   ~ 0
+RSTI
+Wire Wire Line
+	8350 3300 7900 3300
+Wire Wire Line
+	8950 3300 9100 3300
+Text Label 7900 3300 0    60   ~ 0
+INT
+Text Label 9100 3300 0    60   ~ 0
+/DCD
+Text Label 9350 800  0    60   ~ 0
+INT
+Wire Notes Line
+	2750 6700 6450 6700
+$Comp
+L FT231X U4
+U 1 1 5627FA58
+P 5200 4400
+F 0 "U4" H 5200 3900 60  0000 C CNN
+F 1 "FT231X" H 5450 3500 60  0000 C CNN
+F 2 "ch376:SSOP-24_3.9x8.7mm_Pitch0.635mm" H 5200 4600 60  0001 C CNN
+F 3 "" H 5200 4600 60  0000 C CNN
+	1    5200 4400
+	1    0    0    -1  
+$EndComp
+Wire Wire Line
+	5800 5200 6300 5200
+Wire Wire Line
+	6300 5200 6300 5750
+$Comp
+L VCC #PWR022
+U 1 1 56280663
+P 4500 5200
+F 0 "#PWR022" H 4500 5050 50  0001 C CNN
+F 1 "VCC" H 4500 5350 50  0000 C CNN
+F 2 "" H 4500 5200 60  0000 C CNN
+F 3 "" H 4500 5200 60  0000 C CNN
+	1    4500 5200
+	0    -1   -1   0   
+$EndComp
+Wire Wire Line
+	4500 5200 4600 5200
+Wire Wire Line
+	5800 4400 6000 4400
+Wire Wire Line
+	3050 5050 3900 5050
+Wire Wire Line
+	6300 5750 2900 5750
+Wire Wire Line
+	3900 5450 5250 5450
+Connection ~ 5150 5450
+Wire Wire Line
+	5200 5550 5200 5450
+Connection ~ 5200 5450
+Text Label 6200 800  1    60   ~ 0
+CURSOR
+Text Label 900  4600 2    60   ~ 0
+CURSOR
+$Comp
+L R R7
+U 1 1 562AAAE2
+P 6150 4750
+F 0 "R7" V 6230 4750 50  0000 C CNN
+F 1 "4k7" V 6150 4750 50  0000 C CNN
+F 2 "Resistors_SMD:R_0805" V 6080 4750 30  0001 C CNN
+F 3 "" H 6150 4750 30  0000 C CNN
+	1    6150 4750
+	1    0    0    -1  
+$EndComp
+$Comp
+L GND #PWR023
+U 1 1 562AAF90
+P 6350 4600
+F 0 "#PWR023" H 6350 4350 50  0001 C CNN
+F 1 "GND" H 6350 4450 50  0000 C CNN
+F 2 "" H 6350 4600 60  0000 C CNN
+F 3 "" H 6350 4600 60  0000 C CNN
+	1    6350 4600
+	1    0    0    -1  
+$EndComp
+Wire Wire Line
+	6150 4600 6350 4600
+Text Label 5800 4900 0    60   ~ 0
+AWAKE
 $EndSCHEMATC